<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/comments/main.lib.php";
	require_once GEKKO_ROOT."modules/users/main.lib.php";
	require_once GEKKO_ROOT."lib/feeder.lib.php";

	$action = _ext("action", 1);
	$page = _ext("page", 1);
	$id = _ext("id", 2);
	$cpage = _ext("cpage", 3);
	$category = _ext("category");
	$date = _ext("date");

	if (isset($_GET["sub"])) {
		$action = $_GET["sub"];
	}

	switch ($action) {
		case "feed": {

			_l("C_SITE.REL_URL", "");

			$type = _ext("type", 2);

			if (($d = strpos($type, ".")) !== false) $type = substr($type, 0, $d);

			if (($feed = new xml_feed($type)) === false) abort("Unsupported feed type.");

			if ($category) {
				/* category string was provided */
				$access = false;
				$db->query("SELECT ID, auth_Access FROM ".db_table("category")." WHERE Category = '{$category}'", __FILE__, __LINE__);
				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$cat_lock = "Category = '{$row["ID"]}'";
					$access = gauth($row["auth_Access"], "*");
				}
				if (!$access) {
					abort("Access denied");
					break;
				}
			} else {
				/* category lock (allowed categories) */
				$cat_lock = getAllowedCategories(true, "Category", "*");
			}

			$db->query ("
			SELECT
					ID, UserID, Title, Content, CreationTime
			FROM ".db_table("blog")." WHERE Status = '1' AND ($cat_lock)
			ORDER BY CreationTime DESC LIMIT 30
			", __FILE__, __LINE__);

			while ($row = $db->fetch_row()) {
				$feed->create_item();
				// do not save in cache!!
				Format::Style($row["Content"], $row["UserID"]);
				$feed->set_title($row["Title"]);
				$feed->set_link("index.php/blog/view/".$row["ID"]);
				$feed->set_description($row["Content"]);
				$feed->set_date($row["CreationTime"]);
				$feed->set_author($row["UserID"]);
			}
			header("content-type: text/xml; charset=utf-8");
			abort($feed->make());
		}
		case "view": {

			$page = _ext("page");

			if ((intval($id) < 1) && (intval($id = _ext("id")) < 0)) break;

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "blog/post.tpl");

			$tpl->vren("BLOCK_TITLE", "TITLE");
			$tpl->vren("BLOCK_ICON", "ICON");

			$tpl->save();

			$db->query("
				SELECT
				ID, UserID, Category, Icon, Title, Content, Footer, CreationTime, AllowComments
				FROM ".db_table("blog")." WHERE Status = '1' AND ID='{$id}'
			", __FILE__, __LINE__);

			if (!$db->num_rows()) break;

			$row = $db->fetch_row();
			if (!categoryAuth($row["Category"])) { $mcBuff = AccessDenied(); break; }

			saneHTML($row, "Content,Footer");

			Format::Style($row["Content"], $row["UserID"]);

			$row["Icon"] = mkIcon($row["Icon"], 16);
			$row["Category"] = getCategoryByID($row["Category"], 16);
			$row["Author"] = getUserByID($row["UserID"]);
			$row["CommentsLink"] = mkCommentsLink("blog", $row["ID"]);
			$row["Permalink"] = mkLink("index.php/blog/view/{$row["ID"]}", _l("L_PERMALINK"));
			$row["Created"] = dateFormat($row["CreationTime"]);
			$row["Avatar"] = mkUserAvatar($row["UserID"]);

			$tpl->set_arr($row);

			$mcBuff = $tpl->make();

			/* comments */
			$mcBuff .= LoadCommentsBlock (
				"blog",
				$row["ID"],
				"index.php/blog/view/".$row["ID"]."?page=%p",
				$page,
				$row["Title"]
			);
			title_attach($row["Title"], 1);
			break;
		}
		default:

			$date_lock = (is_array($date = timeMark($date))) ? "CreationTime >= '{$date[0]}' AND CreationTime <= '{$date[1]}'": "1";

			if ($category) {
				/* category string was provided */
				$access = false;
				$db->query("SELECT ID, auth_Access FROM ".db_table("category")." WHERE Category = '{$category}'", __FILE__, __LINE__);
				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$cat_lock = "Category = '{$row["ID"]}'";
					$access = gauth($row["auth_Access"]);
				}
				if (!$access) {
					$mcBuff = accessDenied();
					break;
				}
			} else {
				/* category lock (allowed categories) */
				$cat_lock = getAllowedCategories(true);
			}

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "blog/post.tpl");

			/* renaming template vars */
			$tpl->vren("BLOCK_TITLE", "TITLE");
			$tpl->vren("BLOCK_ICON", "ICON");

			/* saving a copy of our modified template */
			$tpl->save();

			/* guessing pages */
			$pager = $db->pager (
				"SELECT ID FROM ".db_table("blog")." WHERE Status = '1' AND ($date_lock) AND ($cat_lock)",
				"index.php/blog/%p".($category ? "?category=".urlencode($category)."":"")."", $page, _c("blog", "items_per_page")
			);

			$db->query ("
			SELECT
					ID, UserID, Category, Icon, Title, Content, Footer, CreationTime, AllowComments
			FROM ".db_table("blog")." WHERE Status = '1' AND ($date_lock) AND ($cat_lock)
			ORDER BY CreationTime DESC ".$pager["sql"]."
			", __FILE__, __LINE__);

			while ($row = $db->fetch_row()) {
				saneHTML($row, "Content");

				/* getting saved copy */
				$tpl->reset();

				Format::Style($row["Content"], $row["UserID"]);

				$row["Icon"] = mkIcon($row["Icon"], 16);
				$row["Category"] = mkLink("index.php/blog?category=".urlencode($c = cache_func("getCategoryByID({$row["Category"]}, 1)")), $c);
				$row["Permalink"] = mkLink("index.php/blog/view/{$row["ID"]}", _l("L_PERMALINK"));
				$row["Title"] = mkLink("index.php/blog/view/".title_encode($row["Title"])."?id={$row["ID"]}", $row["Title"]);
				$row["Author"] = cache_func("getUserByID({$row["UserID"]})");
				$row["CommentsLink"] = mkCommentsLink("blog", $row["ID"]);
				$row["Avatar"] = cache_func("mkUserAvatar({$row["UserID"]})");
				$row["Created"] = dateFormat($row["CreationTime"]);

				/* passing $row to template variables */
				$tpl->set_arr ($row);

				/* updating buffer */
				$mcBuff .= $tpl->make()."\n";
			}
			/* adding a nice pager at bottom */
			$mcBuff .= $pager["html"];

			htdoc_attach("HEAD", '<link rel="alternate" type="application/rss+xml" title="'._l("C_SITE.TITLE").'" href="'._l("C_SITE.URL").'index.php/blog/feed/rss.xml" />');

			htdoc_attach("FOOTER", mkFeederButtons("index.php/blog/feed/%s".($category ? "?category=".urlencode($category) :"")));

		break;

	}

	// saving buffer into modCore
	$mc->save($mcBuff);
?>