<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	class GekkoModule_Blog {
		function create_menu() {
			return false;
		}
		function configure() {
			Conf::getKey("blog", "items_per_page", 8, "i");
			Conf::getKey("blog", "items_per_admin_page", 15, "i");
			Conf::getKey("blog", "allow_user_comments", 1, "b");
		}
		function install() {

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("blog")." (
				ID INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				UserID VARCHAR (32),
				Category SMALLINT (5) UNSIGNED NOT NULL,
				Icon VARCHAR (64),
				Title VARCHAR (128),
				Content TEXT,
				Footer VARCHAR (255),
				CreationTime INT (11) UNSIGNED NOT NULL,
				Status ENUM('0','1') NOT NULL default '1',
				AllowComments ENUM('0','1') NOT NULL default '1'
			)", __FILE__, __LINE__, true);

			modCore::registerModule($GLOBALS["cgdb"]["blog"], "blog", "*", $GLOBALS["cgdb"]["blog"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("blog"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			if (check_version("0.5.8", $provided_v) < 0) {
				$GLOBALS["db"]->query("ALTER TABLE ".db_table("blog")."
				CHANGE COLUMN Status Status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN AllowComments ENUM('0','1') NOT NULL default '1'");
			}
		}
		function ext_uninstall($module) {

		}
	}

?>