<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";

	$category = _ext("category", 1);

	$id = intval(_ext("id"));

	if ($category || $id) {

		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "categories/index.tpl");

		$db->query("SELECT ID, Icon, Category, Description, auth_Access
		FROM ".db_table("category")."
		WHERE Status = '1' AND ".($id ? "ID='{$id}'" : "Category = '".urldecode($category)."'")."",
		__FILE__, __LINE__);

		$row = $db->fetch_row();

		if ($db->num_rows() && gauth($row["auth_Access"])) {
			$id = $row["ID"];
			$row["Icon"] = mkIcon($row["Icon"], 48);
			$entries = 0;

			$modules = modCore::getModules();
			foreach ($modules as $module) {
				$file = GEKKO_ROOT."modules/{$module}/mod_categories.inc.php";
				if (!file_exists($file)) continue;

				$data = Array();
				/*
					included file will set variable $data as an array
					containing two subarrays:
						entries: module query results

						module: main module information
				*/
				include ($file);
				if (count($data["entries"])) {
					$tpl->reset("MODULE.ENTRY");
					foreach ($data["entries"] as $entry) {
						$tpl->set_arr($entry, "MODULE.ENTRY");
						$tpl->saveBuff("MODULE.ENTRY");
						$entries++;
					}
					$tpl->set_arr($data["module"], "MODULE");
					$tpl->saveBuff("MODULE");
				}
			}

			$tpl->set_arr($row);
			$tpl->set_arr(
				Array (
					"BLOCK_TITLE" => _l("L_CATEGORY"),
					"BLOCK_ICON" => mkIcon("categories.png", 16),
					"ENTRIES" => $entries
				)
			);
			$mcBuff = $tpl->make();
		} else {
			$mcBuff = accessDenied();
		}
	} else {

		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "categories/category.tpl");

		$db->query ("
		SELECT
			ID, Icon, Category, Description, auth_Access
		FROM ".db_table("category")." WHERE Status = '1'
		ORDER BY Category ASC
		", __FILE__, __LINE__);

		$i = 0;
		while ($row = $db->fetch_row()) {
			$m = ($i%2);
			if (!gauth($row["auth_Access"])) continue;
			$row["Category"] = mkLink("index.php/categories/".urlencode($row["Category"])."", $row["Category"]);
			$row["Icon"] = mkIcon($row["Icon"], 48);

			$row["TR_BGN"] = ($m) ? "": "<tr>";
			$row["TR_END"] = ($m) ? "</tr>": "";

			$tpl->set_arr($row, "CATEGORY");
			$tpl->saveBuff("CATEGORY");
			$i++;
		}

		$tpl->set_arr (
			Array (
				"BLOCK_TITLE" => _l("L_CATEGORIES"),
				"BLOCK_ICON" => mkIcon("categories.png", 16),
				"TR_END" => (($i%2) ? "<td></td>\n</tr>" : "")
			)
		);

		$mcBuff = $tpl->make();

	}

	// saving buffer into modCore
	$mc->save($mcBuff);
?>