<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";
	require_once GEKKO_ROOT."modules/comments/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);
/*
	// setting antiflood rule
	$forum_antiflood = $AccessTable->set_generic_rule("forum", "post");
*/
	$is_admin = gauth("comments");
	$auth_edit = false;

	if (!$is_admin && !is_array($id)) {
		$db->query("SELECT CreationTime, UserID FROM ".db_table("comment")." WHERE ID = '{$id}'");
		$row = $db->fetch_row();
		$auth_edit = comment_authEdit($id, $row["CreationTime"], $row["UserID"]);
	}

	switch ($action) {
		case "delete":
			if (!($is_admin || $auth_edit)) abort(accessDenied());
			execWithEach($id, "deleteComment");
		break;
		case "post":

			// generic antiflood protection
			$antiflood = $AccessTable->set_generic_rule("comments", "post");
			$AccessTable->load_rule($antiflood, "E_ANTI_FLOOD");

			gpGlobalize("thread, module, nickname, email, title, icon, content");

			requireVars($thread, $module, $title, $content);

			rtb_codefix($content);

			if (allowComment($module, $thread)) {
				$db->query ("
				INSERT INTO ".db_table("comment")."
					(
						ID,
						Module,
						Thread,
						UserID,
						Nickname,
						Email,
						Icon,
						Title,
						Content,
						CreationTime,
						IPAddr
					)
						VALUES
					(
						'".$db->free_id("comment")."',
						'{$module}',
						'{$thread}',
						'{$User["ID"]}',
						'{$nickname}',
						'{$email}',
						'{$icon}',
						'{$title}',
						'{$content}',
						'".time()."',
						'".IP_ADDR."'
					)
				", __FILE__, __LINE__);
			}

			slog("comments: comment from ".getIP().", thread: $module.$thread", "actions", 2);
		break;
		case "edit":
			if (!($is_admin || $auth_edit)) abort(accessDenied(true));

			gpGlobalize("id, thread, module, nickname, email, title, icon, content");

			requireVars($id, $thread, $module, $title, $content);

			rtb_codefix($content);

			$db->query("
				UPDATE ".db_table("comment")." SET
					".($is_admin ? "Nickname = '{$nickname}'," : "")."
					".($is_admin ? "Email = '{$email}'," : "")."
					Icon = '{$icon}',
					Title = '{$title}',
					Content = '{$content}'
				WHERE ID = '{$id}' ".($is_admin ? "" : " AND UserID = '{$User["ID"]}'")."
			", __FILE__, __LINE__);

			slog("comment: comment '$id' was updated", "actions", 2);
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>