<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/



	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/users/main.lib.php";
	require_once GEKKO_ROOT."modules/comments/main.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";

	$action = _ext("action", 1);
	$page = _ext("page", 1);
	$id = _ext("id", 2);

	if (gateKeeper("comments", _l("C_AUTH_STR"), false)) {
		switch ($action) {
			case "edit":
				if (!$id) break;

				$db->query ("
				SELECT
					ID, Module, Thread, Icon, Title, Content, Nickname, Email, UserID, CreationTime
				FROM ".db_table("comment")." WHERE ID = '{$id}'
				", __FILE__, __LINE__);

					if ($db->num_rows() && ($row = $db->fetch_row()) && comment_authEdit($row["ID"], $row["CreationTime"], $row["UserID"])) {

					saneHTML($row);

					$rtb = new rtbEditor($row["Content"]);
					$rtb->setSize(350, 150);

					$row["IconChooser"] = mkIconChooser(16, $row["Icon"]);
					$row["Icon"] = mkIcon($row["Icon"], 16);
					$row["rtbEditor"] = $rtb->make();
					$row["ACTION"] = "edit";
					$row["RETURN"] = local_referer();
					$row["AUTH"] = (!gauth("comment"));

					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "comments/comment.form.tpl");
					$tpl->vren("BLOCK_ICON", "ICON");
					$tpl->vren("BLOCK_TITLE", "TITLE");
					$tpl->set_arr($row);

					$mcBuff = $tpl->make();
				} else {
					$mcBuff = accessDenied();
				}

			break;
			case "view":
				if (!$id) break;

				$db->query ("
				SELECT
					ID, UserID, Nickname, Email, Icon, Title, Content, CreationTime, IPAddr
				FROM ".db_table("comment")." WHERE ID = '{$id}'
				", __FILE__, __LINE__);

				if (!$db->num_rows()) break;

				$row = $db->fetch_row();
				saneHTML($row, "Content");

				Format::Style($row["Content"], $row["UserID"]);

				$row["ICON"] = mkIcon($row["Icon"], 16);
				$row["Author"] = mkCommentsUserLink($row["UserID"], $row["IPAddr"], $row["Nickname"], $row["Email"]);
				$row["Buttons"] = mkCommentsButtonBox($row["ID"], comment_authEdit($row["ID"], $row["CreationTime"], $row["UserID"]));
				$row["CreationDate"] = dateFormat($row["CreationTime"]);

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "comments/comment.tpl");

				$tpl->vren("BLOCK_ICON", "ICON");
				$tpl->vren("BLOCK_TITLE", "TITLE");

				$tpl->set_arr($row, "COMMENT");
				$tpl->saveBuff("COMMENT");

				$tpl->set_arr(
					Array (
						"TITLE" => _l("L_COMMENTS"),
						"COMMENTS_TITLE" => _l("L_VIEW_COMMENT"),
						"ICON" => mkIcon("comments.png", 16)
					)
				);

				$mcBuff = $tpl->make();
			break;
			default: {
				$buff = new BlockWidget();
				$buff->load("comments/comment.tpl");
				$buff->vren("COMMENTS", "LAST_COMMENTS");

				$pager = $db->pager(
					"SELECT ID FROM ".db_table("comment")."",
					"index.php/comments/%p", $page, conf::getkey("comments", "items_per_page")
				);

				$db->query("
					SELECT
						ID, Module, Thread, UserID, Nickname, Email, Icon, Title, Content, CreationTime, IPAddr
					FROM ".db_table("comment")."
					ORDER BY CreationTime DESC ".$pager["sql"]."
				", __FILE__, __LINE__);

				if (!$db->num_rows()) break;

				while ($row = $db->fetch_row()) {

					saneHTML($row, "Content");


					Format::Style($row["Content"], $row["UserID"]);

					$row["Icon"] = mkIcon($row["Icon"], 16);
					$row["CreationDate"] = dateFormat($row["CreationTime"]);
					$row["Author"] = mkCommentsUserLink($row["UserID"], $row["IPAddr"], $row["Nickname"], $row["Email"]);
					$row["Buttons"] = mkCommentsButtonBox($row["ID"], comment_authEdit($row["ID"], $row["CreationTime"], $row["UserID"]));
					$row["Title"]= mkLink("index.php/{$row["Module"]}/{$row["Thread"]}", $row["Title"]);

					$buff->set_arr($row, "COMMENT");
					$buff->saveBuff("COMMENT");
				}

				$buff = $buff->make();
				$buff .= $pager["html"];

				$mcBuff = $buff;
			}
		}
	} else {
		$mcBuff = accessDenied();
	}

	// saving buffer into modCore
	$mc->save($mcBuff);

?>