<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	//header("content-type: text/plain");
	function LoadCommentsBlock($module, $thread, $url, $page = 1, $title = null) {

		$comm = "";
		$comm .= loadComments($module, $thread, $url, $page);
		$comm .= loadCommentForm($module, $thread, $title);

		if ($comm) {
			$tpl = new ContentBlock();
			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => _l("L_COMMENTS"),
					"BLOCK_ICON" => mkIcon("comments.png", 16),
					"BLOCK_CONTENT" => $comm
				)
			);
			return $tpl->make();
		} else {
			return "";
		}
	}
	function getCommentsCount($module, $thread) {
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("comment")." WHERE Module = '$module' AND Thread = '$thread'", __FILE__, __LINE__,true);
		return intval($GLOBALS["db"]->num_rows($q));
	}
	function deleteComments($module, $thread) {
		slog("comments: deleted comments (module=$module thread=$thread)", "actions", 1);
		return $GLOBALS["db"]->query("DELETE FROM ".db_table("comment")." WHERE Module = '{$module}' AND Thread = '{$thread}'", __FILE__, __LINE__, true);
	}
	function mkCommentsLink($module, $thread, $link = null) {
		/* comments are enabled? */
		if (!Conf::getKey($module, "allow_user_comments", 0, "boolean")) return _l("L_COMMENTS_DISABLED");
		$c = getCommentsCount($module, $thread);
		return mkLink(($link ? $link : "index.php/$module/view/$thread")."#comment", ($c ? _l("L_COMMENTS").": $c" : _l("L_POST_A_COMMENT")));
	}
	function deleteComment($id) {
		slog("comments: comment '$id' was deleted", "actions", 1);
		return $GLOBALS["db"]->query ("DELETE FROM ".db_table("comment")." WHERE ID='".$id."'", __FILE__, __LINE__, true);
	}
	function loadCommentForm($module, $thread, $title = null, $data = null) {
		$buff = "";
		if (allowComment($module, $thread)) {
			$buff = $GLOBALS["T"]->load("comments/comment.form.tpl");
			$rtb = new rtbEditor();
			$rtb->setSize(350, 150);
			if (!$data) {
				$data = Array (
					"V_THREAD" => "$thread",
					"V_MODULE" => "$module",
					"V_ACTION" => "post",
					"V_TITLE" => "Re: $title",
					"V_RTBEDITOR" => $rtb->make(),
					"V_ICONCHOOSER" => mkIconChooser(16, "comments.png"),
					"V_RETURN" => "",
					"V_NICKNAME" => "",
					"V_EMAIL" => ""
				);
			}
			$data["V_AUTH"] = gauth("$");
			$buff = $GLOBALS["T"]->make($GLOBALS["T"]->parse($buff, $data, 1));
		}
		return $buff;
	}

	function comment_authEdit($id, $creation, $authorid) {
		return (gauth("comment") || (gauth("$") && ($authorid == $GLOBALS["User"]["ID"]) && ($creation+conf::getKey("comments", "edit_time")) >= time()));
	}

	function loadComments($module, $thread, $url_prototype, $page = 1) {

		if (allowComment($module, $thread)) {

			$buff = new BlockWidget();
			$buff->load("comments/comment.tpl");

			$pager = $GLOBALS["db"]->pager(
				"SELECT ID FROM ".db_table("comment")." WHERE Module = '$module' AND Thread = '$thread'",
				$url_prototype, $page, conf::getKey("comments", "items_per_page")
			);

			$q = $GLOBALS["db"]->query("
				SELECT
					ID, UserID, Nickname, Email, Icon, Title, Content, CreationTime, IPAddr
				FROM ".db_table("comment")." WHERE Module = '$module' AND Thread = '$thread'
				ORDER BY CreationTime ASC ".$pager["sql"]."
			");

			if (!$GLOBALS["db"]->num_rows()) return "";

			$sw = 0;
			while ($row = $GLOBALS["db"]->fetch_row($q)) {
				saneHTML($row, "Content");

				Format::Style($row["Content"], $row["UserID"]);

				$row["Icon"] = mkIcon($row["Icon"], 16);
				$row["SW_CLASS"] = sw_class($sw);
				$row["CreationDate"] = dateFormat($row["CreationTime"]);
				$row["Avatar"] = mkUserAvatar($row["UserID"]);
				$row["Author"] = mkCommentsUserLink($row["UserID"], $row["IPAddr"], $row["Nickname"], $row["Email"]);
				$row["Buttons"] = mkCommentsButtonBox($row["ID"], comment_authEdit($row["ID"], $row["CreationTime"], $row["UserID"]));
				$buff->set_arr($row, "COMMENT");
				$buff->saveBuff("COMMENT");
			}
			$buff->set_arr (
				Array (
					"COMMENTS_TITLE" => ""
				)
			);

			$buff = $buff->make();

			$buff .= $pager["html"];

		return $buff;
		} else {
			return false;
		}
	}
	function mkCommentsUserLink($uid, $ip, $nickname = null, $email = null) {
		return ($author = cache_func("getUserByID($uid)")) ? $author : "&lt;".safeLink($email, $nickname ? $nickname : _l("L_ANONYMOUS"))."&gt; (".$ip.")";
	}
	function mkCommentsButtonBox($id, $editable = false) {
		$buttonBox = new buttonBox();
		if ($editable) {
			$buttonBox->add("index.php/comments/edit/".$id."", _l("L_EDIT"));
			$buttonBox->add("modules/comments/main.act.php?action=delete&id=".$id."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), null, 1);
		}
		return $editable ? $buttonBox->make() : "";
	}

	function allowComment($module, $thread) {
		$return = false;

		if (!Conf::getKey($module, "allow_user_comments", 0)) return false;

		$lib = GEKKO_ROOT."modules/$module/main.lib.php";
		if (file_exists($lib)) require_once $lib;

		if (function_exists($module."AllowComment")) {
			eval("\$return = ".$module."AllowComment($thread);");
		}
		return $return;
	}
?>