<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";
	require_once GEKKO_ROOT."lib/template.lib.php";
	require_once GEKKO_ROOT."lib/network.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	switch ($action) {
		case "submit":

			// antiflood protection
			$antiflood = $AccessTable->set_generic_rule("contact-message", "post");
			$AccessTable->load_rule($antiflood, "E_ANTI_FLOOD");

			gpGlobalize("subject, sender, sendermail, message");

			requireVars($subject, $sender, $sendermail, $message);

			if ((strpos($sendermail, "\n") !== false) || (strpos($sender, "\n") !== false) || (strpos($subject, "\n") !== false)) {
				abort("WTF?!");
			}

			if (preg_match("/[^a-zA-Z0-9\._@\-]/", $sendermail) || (!ereg("@", $sendermail)))
				abort(_l("E_INVALID_MAIL_ADDR"));
			// sending mail
			sendmail(conf::getkey("core", "site.contact_mail"),
			_l("L_CONTACT_MESSAGE"),
				mkLetter("contact/feedback",
					Array (
						"SUBJECT" => $subject,
						"SENDER" => $sender,
						"SENDERMAIL" => $sendermail,
						"SENDERIP" => getIP(),
						"MESSAGE" => $message
					)
				),
				"text/plain",
				"Reply-To: $sendermail\r\n"
			);

			slog("contact: received message from $sendermail", "actions", 1);

			$return = "../../index.php?message=".urlencode(_l("L_MESSAGE_SENT"))."";
		break;
		case "send":

			if (!is_admin())
				abort(accessDenied(true, __FILE__, __LINE__));

			gpGlobalize("to, subject, message");

			requireVars($to, $message);

			// sending mail
			sendmail($to, $subject, $message, "text/plain");

			slog("contact: message sent to $to", "actions", 1);

			$return = "../../index.php/admin";
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>