<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/downloads/main.lib.php";

	$action = _ext("action", 2);
	$id = _ext("id", 3);

	switch ($action) {
		case "item":
			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/category.admin.tpl");
			$tpl->insert("ITEM.FORM", "downloads/item.form.tpl");

			$db->query("SELECT ID, DownloadLink, Title, Description,
			Thumbnail, ThumbnailSize, DownloadURL, AuthorID,
			LastUpdated, CreationTime, AllowComments, Filesize
			FROM ".db_table("download_item")." WHERE ID = '$id'", __FILE__, __LINE__);

			$row = $db->fetch_row();

			$tpl->set_arr($row);

			$db->query("SELECT Title FROM ".db_table("download")." WHERE ID = '{$row["DownloadLink"]}'", __FILE__, __LINE__);
			$row2 = $db->fetch_row();

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => $row2["Title"],
					"BLOCK_SUBTITLE" => _l("L_EDIT_ITEM"),
					"BLOCK_ICON" => mkIcon("download.png", 16),
					"SUBCATEGORIES.SEL" => mkSelect(getDownloadCats(false), $row["DownloadLink"], "downloadlink"),
					"ACTION" => "edit_item",
					"OPTIONS" => mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), $row["AllowComments"]),
					"ITEMS" => 0,
					"RETURN" => ""
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "items":

			$page = _ext("page", 4);

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/category.admin.tpl");
			$tpl->insert("ITEM.FORM", "downloads/item.form.tpl");

			$pager = $db->pager (
				"SELECT ID FROM ".db_table("download_item")." WHERE DownloadLink = '{$id}'",
				"index.php/admin/downloads/items/{$id}/%p#items", $page, conf::getkey("downloads", "items_per_admin_page")
			);

			$db->query("SELECT ID, Title, Description, Thumbnail, ThumbnailSize,
			DownloadURL, AllowComments, LastUpdated, AuthorID, Filesize
			FROM ".db_table("download_item")." WHERE
			DownloadLink = '{$id}' ORDER BY Title ASC ".$pager["sql"]."", __FILE__, __LINE__);

			$items = $db->num_rows();

			while ($row = $db->fetch_row()) {
				if ($row["Thumbnail"]) {
					list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["ThumbnailSize"]);
				}
				$row["AUTHOR"] = getUserById($row["AuthorID"]);
				$row["MODIFIED"] = dateFormat($row["LastUpdated"]);
				$row["Filesize"] = size_r($row["Filesize"]);
				$row["ACTIONS"] = mkButtonDisplay (
					Array (
						mkLink("index.php/admin/downloads/item/".$row["ID"], _l("L_EDIT")),
						mkLink("modules/downloads/main.act.php?action=delete_item&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1),
					)
				);
				$tpl->set_arr($row, "ITEM");
				$tpl->saveBuff("ITEM");
			}

			$db->query("SELECT Title FROM ".db_table("download")." WHERE ID = '{$id}'", __FILE__, __LINE__);
			$row = $db->fetch_row();

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => $row["Title"],
					"BLOCK_SUBTITLE" => _l("L_ADD_ITEM"),
					"BLOCK_ICON" => mkIcon("download.png", 16),
					"SUBCATEGORIES.SEL" => mkSelect(getDownloadCats(), $id, "downloadlink"),
					"TITLE" => "",
					"ACTION" => "add_item",
					"DESCRIPTION" => "",
					"FILESIZE" => 0,
					"ITEMS" => $items,
					"PAGER" => $pager["html"],
					"OPTIONS" => mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), 1),
					"RETURN" => ""
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "edit":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/index.admin.tpl");
			$tpl->insert("CATEGORY.FORM", "downloads/category.form.tpl");

			$db->query("SELECT
			ID, CategoryLink, Title, Description, Status, Thumbnail,
			ThumbnailSize, AuthorID, LastUpdated, auth_Access
			FROM ".db_table("download")." WHERE ID = '{$id}'
			", __FILE__, __LINE__);

			$row = $db->fetch_row();
			if ($row["Thumbnail"]) {
				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["ThumbnailSize"]);
			}

			$row["AUTHOR"] = getUserById($row["AuthorID"]);
			$row["MODIFIED"] = dateFormat($row["LastUpdated"]);

			$tpl->set_arr($row);

			$tpl->set_arr (
				Array (
					"BLOCK_ICON" => mkIcon("downloads.png", 16),
					"BLOCK_TITLE" => $row["Title"],
					"BLOCK_SUBTITLE" => _l("L_EDIT_CATEGORY"),
					"STATUS.SEL" => mkSelect(Array(_l("L_DISABLED"), _l("L_ENABLED")), $row["Status"], "status"),
					"CATEGORIES.SEL" => mkSelect(getCategories(), $row["CategoryLink"], "categorylink"),
					"ACTION" => "edit",
					"GALLERIES" => 0,
					"RETURN" => ""
				)
			);

			$mcBuff = $tpl->make();

		break;
		default:

			$categories = getCategories(true);

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/index.admin.tpl");
			$tpl->insert("CATEGORY.FORM", "downloads/category.form.tpl");

			$db->query("SELECT
			ID, Title, Description, CategoryLink, Status, Thumbnail, ThumbnailSize,
			AuthorID, LastUpdated
			FROM ".db_table("download")."
			ORDER BY CategoryLink ASC, Title ASC", __FILE__, __LINE__);

			$downloads = $db->num_rows();
			$catnames = Array();
			while ($row = $db->fetch_row()) {

				if (!isset($catnames[$row["CategoryLink"]])) {
					if (count($catnames)) {
						// saving buffer & reseting subcategory block
						$tpl->saveBuff("CATEGORY");
						$tpl->reset("CATEGORY.SUBCATEGORY");
					}
					// new category
					$catnames[$row["CategoryLink"]] = 1;
					$tpl->set_arr(Array("CATEGORY" => getCategoryById($row["CategoryLink"], true)), "CATEGORY");
				}

				if ($row["ThumbnailSize"]) {
					$thumbsize = explode("x", $row["ThumbnailSize"]);
					$row["THUMBNAIL.WIDTH"] = $thumbsize[0];
					$row["THUMBNAIL.HEIGHT"] = $thumbsize[1];
				}

				$row["AUTHOR"] = getUserById($row["AuthorID"]);
				$row["MODIFIED"] = dateFormat($row["LastUpdated"]);
				$row["ITEMS"] = countDownloadItems($row["ID"]);

				$row["ACTIONS"] = mkButtonDisplay (
					Array (
						mkLink("index.php/admin/downloads/items/".$row["ID"], _l("L_ITEMS")),
						mkLink("index.php/admin/downloads/edit/".$row["ID"], _l("L_EDIT")),
						mkLink("modules/downloads/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1),
						mkLink("modules/downloads/main.act.php?action=".($row["Status"] ? "disable" : "enable")."&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_".($row["Status"] ? "DISABLED" : "ENABLED").""))
					)
				);

				$tpl->set_arr($row, "CATEGORY.SUBCATEGORY");
				$tpl->saveBuff("CATEGORY.SUBCATEGORY");
			}
			$tpl->saveBuff("CATEGORY");

			$tpl->set_arr (
				Array (
					"BLOCK_ICON" => mkIcon("downloads.png", 16),
					"BLOCK_TITLE" => _l("L_DOWNLOADS"),
					"BLOCK_SUBTITLE" => _l("L_CREATE_CATEGORY"),
					"STATUS.SEL" => mkSelect(Array(_l("L_DISABLE"), _l("L_ENABLE")), 1, "status"),
					"CATEGORIES.SEL" => mkSelect($categories, 0, "categorylink"),
					"ACTION" => "create",
					"TITLE" => "",
					"DESCRIPTION" => "",
					"THUMBNAIL" => "",
					"AUTH_ACCESS" => "*",
					"CATEGORIES" => $downloads,
					"RETURN" => ""
				)
			);
			$mcBuff = $tpl->make();

		break;
	}

?>