<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/comments/main.lib.php";
	require_once GEKKO_ROOT."modules/downloads/main.lib.php";
	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";

	$action = _ext("action", 1);
	$page = _ext("page", 1);
	$id = _ext("id", 2);

	switch ($action) {
		case "get":
			$id = _ext("id");
			if (is_numeric($id)) {

				$cat_lock = "(DownloadLink = '".implode("' OR DownloadLink ='", allowedDownloadCategories())."')";

				$db->query("SELECT DownloadURL, DownloadLink
				FROM ".db_table("download_item")." WHERE ID = '{$id}' AND $cat_lock",
				__FILE__, __LINE__);

				$row = $db->fetch_row();
				header("Location: ".rel_link($row["DownloadURL"])."");

				abort();
			}
		break;
		case "view":
			/* external variables */

			// getting id
			$id = intval($id);
			if ($id < 1 || _ext("id")) $id = _ext("id");

			// getting page
			$page = _ext("page", 3);

			if ($id) {

				$tpl = new contentBlock();
				$tpl->insert("BLOCK_CONTENT", "downloads/view.tpl");

				$db->query("SELECT ID, Title, Description, DownloadURL, Thumbnail,
				ThumbnailSize, AuthorID, LastUpdated, AllowComments, Filesize
				FROM ".db_table("download_item")." WHERE ID = '{$id}'", __FILE__, __LINE__);

				$row = $db->fetch_row();

				if ($row["Thumbnail"])
					list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["ThumbnailSize"]);

				$row["DownloadURL"] = rel_link($row["DownloadURL"]);
				$row["AUTHOR"] = getUserById($row["AuthorID"]);
				$row["BLOCK_TITLE"] = $row["Title"];
				$row["Filesize"] = size_r($row["Filesize"]);
				$row["BLOCK_ICON"] = mkIcon("downloads.png", 16);
				$row["TITLE_ID"] = urlencode($row["Title"]);

				$tpl->set_arr($row);

				$mcBuff = $tpl->make();

				if ($row["AllowComments"]) {
					/* comments */
					$mcBuff .= LoadCommentsBlock (
						"downloads",
						$row["ID"],
						"index.php/downloads/view/".urlencode($row["Title"])."?id={$row["ID"]}&page=%p",
						$page,
						$row["Title"]
					);
				}
			}
		break;
		case "items":

			$id = _ext("id");
			$page = _ext("page");

			$tpl = new contentBlock();

			$tpl->insert("BLOCK_CONTENT", "downloads/items.tpl");

			$db->query("SELECT
			ID, Title, Description, Thumbnail, ThumbnailSize, auth_Access
			FROM ".db_table("download")." WHERE ID = '{$id}'",
			__FILE__, __LINE__);

			$row = $db->fetch_row();

			if ($db->num_rows() && gauth($row["auth_Access"])) {

				$pager = $db->pager (
					"SELECT ID FROM ".db_table("download_item")."
					WHERE DownloadLink = '{$row["ID"]}'",
					"index.php/downloads/items/".urlencode($row["Title"])."?id={$row["ID"]}&page=%p", $page, conf::getkey("downloads", "items_per_page")
				);

				$db->query("SELECT ID, Title, Description, Thumbnail, ThumbnailSize,
				LastUpdated, AuthorID, AllowComments, DownloadURL, Filesize
				FROM ".db_Table("download_item")."
				WHERE DownloadLink = '{$row["ID"]}' {$pager["sql"]}", __FILE__, __LINE__);

				$items = $db->num_rows();

				$sw = 0;
				while ($row2 = $db->fetch_row()) {
					saneHTML($row2, "Description");
					$row2["SW_CLASS"] = sw_class($sw);
					$row2["Filesize"] = size_r($row2["Filesize"]);
					downloadFixRow($row2, true);

					$row2["ACTIONS"] = mkButtonDisplay (
						Array (
							mkLink("index.php/downloads/get/".$row2["TITLE_ID"]."?id=".$row2["ID"], _l("L_DOWNLOAD"), "downloads.png", false, "icon")
						)
					);

					$row2["COMMENTSLINK"] = $row2["AllowComments"] ? mkCommentsLink("downloads", $row2["ID"], "index.php/downloads/view/{$row2["TITLE_ID"]}?id={$row2["ID"]}") : "";
					$tpl->set_arr($row2, "ITEM");
					$tpl->savebuff("ITEM");
				}

				$tpl->set_arr ($row);

				$subcategories = 0;
				$tpl->set_arr (
					Array (
						"BLOCK_TITLE" => _l("L_DOWNLOADS"),
						"BLOCK_ICON" => mkIcon("downloads.png", 16),
						"BLOCK_SUBTITLE" => $row["Title"],
						"ITEMS" => $items,
						"SUBCATEGORIES" => $subcategories,
						"PAGER" => $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			} else {
				$mcBuff = accessDenied();
			}

		break;
		default: {

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/index.tpl");

			$allowed_cats = "(ID = '".implode("' OR ID ='", allowedDownloadCategories())."')";

			$pager = $db->pager (
				"SELECT ID FROM ".db_table("download")."
				WHERE {$allowed_cats} ORDER BY Title DESC",
				"index.php/downloads/%p", $page, conf::getKey("downloads", "items_per_page")
			);

			$db->query("SELECT
			ID, Title, Description, CategoryLink, Thumbnail, ThumbnailSize, AuthorID, LastUpdated
			FROM ".db_table("download")." WHERE {$allowed_cats} ORDER BY
			CategoryLink ASC, Title ASC {$pager["sql"]}", __FILE__, __LINE__);

			$categories = $db->num_rows();
			$catnames = Array();

			while ($row = $db->fetch_row()) {
				if (!isset($catnames[$row["CategoryLink"]])) {
					if (count($catnames)) {
						$tpl->saveBuff("CATEGORY");
						$tpl->reset("CATEGORY.SUBCATEGORY");
					}
					$catnames[$row["CategoryLink"]] = 1;
					$sw = 0;
					$tpl->set_arr(Array("ICON" => CategoryIcon($row["CategoryLink"]), "CATEGORY" => getCategoryById($row["CategoryLink"], true)), "CATEGORY");
				}
				downloadFixRow($row);
				$row["SW_CLASS"] = sw_class($sw);
				$tpl->set_arr($row, "CATEGORY.SUBCATEGORY");
				$tpl->savebuff("CATEGORY.SUBCATEGORY");
			}
			$tpl->saveBuff("CATEGORY");

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => _l("L_DOWNLOADS"),
					"BLOCK_ICON" => mkIcon("downloads.png", 16),
					"PAGER" => $pager["html"],
					"CATEGORIES" => $categories
				)
			);

			$mcBuff = $tpl->make();

		}
	}

	// saving buffer into modCore
	$mc->save($mcBuff);

?>