<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";
	require_once GEKKO_ROOT."lib/file.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	if (!gauth("files")) abort(accessDenied());

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	switch ($action) {
		case "delete":
			gpGlobalize("file");

			requireVars($file);

			$file = str_replace("../", "", $file);

			$path = GEKKO_ROOT.$file;

			if (file_exists($path) && is_writable($path)) {
				if (is_dir($path)) {
					// recursive deletion
					$files = listdir($path, true);
					while ($file = array_shift($files)) {
						$file = $path."/".$file;
						if (is_dir($file)) {
							@rmdir($file);
						} else {
							@unlink($file);
						}
					}
					@rmdir($path);
				} else {
					// single file deletion
					@unlink($path);
				}
			} else {
				abort(_l("E_NOT_WRITABLE"));
			}

			slog("files: deleted '$file'", "actions", 1);
		break;
		case "fileprop":

			gpGlobalize("path, file, parent, perm");

			requireVars($path, $file, $parent, $perm);

			$full = GEKKO_ROOT.$path;

			// permissions
			// converting to binary
			$ugo = Array("U", "G", "O");
			$rwx = Array("R", "W", "X");
			$bin = "";

			foreach ($ugo as $l) {
				foreach ($rwx as $p) {
					$bin .= intval(isset($_POST["perm"][$l.$p]));
				}
			}
			// binary to octal
			$oct = base_convert($bin, 2, 8);
			// chmod()
			chmod($full, intval($oct, 8));

			// filename change (couldn't change data/files)
			if ((basename($path) != $file) && ($path != "data/files")) {
				// you could use "../" ;)
				$return = str_replace("/".basename($path)."?action=edit", "/".$file."?action=edit", $_SERVER["HTTP_REFERER"]);
				rename($full, $full = GEKKO_ROOT.dirname($path)."/".$file);
			}

			slog("files: changed properties of '$file'", "actions", 1);
		break;
		case "upload":

			gpGlobalize("path, mkdir, new, download");

			requireVars($path);

			// checking path...
			$path = trim(str_replace("../", "", $path), "/");
			if ($path)
				$path .= "/";

			$workdir = GEKKO_ROOT.$path;

			if (!$path || !file_exists($workdir))
				break;

			if (!is_writable($workdir))
				abort(_l("E_NOT_WRITABLE"));

			// mkdir
			foreach ($mkdir as $new_dir) {
				if (!trim($new_dir))
					break;
				$new_dir = $workdir.$new_dir;
				@mkdir($new_dir, 0775);
				@chmod($new_dir, 0775);
			}

			// empty file
			foreach ($new as $file) {
				if (!trim($file))
					break;
				$file = $workdir.$file;
				touch($file);
				chmod($file, 0775);
			}

			foreach ($_FILES["file"]["tmp_name"] as $id => $tmp) {
				if ($_FILES["file"]["name"][$id]) {
					if ($_FILES["file"]["error"][$id]) {
						trigger_error(uploadError($_FILES["file"]["name"][$id]), E_USER_ERROR);
					}
					if (trim($tmp)) {
						saveFile (
							$tmp,
							$path,
							$_FILES["file"]["name"][$id],
							true
						);
					}
				}
			}

			// download from url
			foreach ($download as $url) {
				if (trim($url)) {
					saveFile (
						$url,
						$path,
						basename(urldecode($url))
					);
				}
			}

			slog("file: file was uploaded/downloaded", "actions", 1);
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>