<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	function readable_perms($perms) {
		/* Borrowed from php.net */

		if (($perms & 0xC000) == 0xC000) {
			// Socket
			$info = 's';
		} elseif (($perms & 0xA000) == 0xA000) {
			// Symbolic Link
			$info = 'l';
		} elseif (($perms & 0x8000) == 0x8000) {
			// Regular
			$info = '-';
		} elseif (($perms & 0x6000) == 0x6000) {
			// Block special
			$info = 'b';
		} elseif (($perms & 0x4000) == 0x4000) {
			// Directory
			$info = 'd';
		} elseif (($perms & 0x2000) == 0x2000) {
			// Character special
			$info = 'c';
		} elseif (($perms & 0x1000) == 0x1000) {
			// FIFO pipe
			$info = 'p';
		} else {
			// Unknown
			$info = 'u';
		}

		// Owner
		$info .= (($perms & 0x0100) ? 'r' : '-');
		$info .= (($perms & 0x0080) ? 'w' : '-');
		$info .= (($perms & 0x0040) ? (($perms & 0x0800) ? 's' : 'x' ) : (($perms & 0x0800) ? 'S' : '-'));

		// Group
		$info .= (($perms & 0x0020) ? 'r' : '-');
		$info .= (($perms & 0x0010) ? 'w' : '-');
		$info .= (($perms & 0x0008) ? (($perms & 0x0400) ? 's' : 'x' ) : (($perms & 0x0400) ? 'S' : '-'));

		// World
		$info .= (($perms & 0x0004) ? 'r' : '-');
		$info .= (($perms & 0x0002) ? 'w' : '-');
		$info .= (($perms & 0x0001) ? (($perms & 0x0200) ? 't' : 'x' ) : (($perms & 0x0200) ? 'T' : '-'));

		return $info;

	}

	function mkFileIcon($file, $size = 48) {
		$extension = file_extension($file);

		switch ($extension) {
			case "jpg": case "jpeg": case "png": case "gif": case "bmp": case "tiff":
				$icon = "image";
			break;
			case "mpg": case "mpeg": case "avi": case "mpg":
				$icon = "video";
			break;
			case "mp3": case "ogg": case "wav":
				$icon = "audio";
			break;
			case "mid": case "midi":
				$icon = "midi";
			break;
			case "txt": case "asc":
				$icon = "text";
			break;
			case "o": case "f": case "h": case "sql":
				$icon = "source";
			break;
			default:
				$icon = $extension;
			break;
		}

		if (is_dir($file)) {
			return mkIcon("files/folder.png", $size);
		} else {
			// icon exists?
			$icondir = GEKKO_ROOT."media/icons/"._l("C_SITE.ICONTHEME")."/{$size}/files/";
			if (!file_exists($icondir.$icon.".png")) $icon = "unknown";

			return mkIcon("files/".$icon.".png", $size);
		}
	}

	function get_file_type($file) {
		// php >= 4.3.0
		return function_exists("mime_content_type") ? mime_content_type($file) : file_extension($file);
	}


?>