<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";

	require_once GEKKO_ROOT."modules/forums/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	/* user has temporary privileges to edit his messages? */
	$auth_edit = false;

	if (!is_admin() && $id) {
		$db->query("SELECT ID, CreationTime, UserID
		FROM ".db_table("forum_message")." WHERE ID = '{$id}'");
		$row = $db->fetch_row();

		$auth_edit = forumMessage_authEdit($id, $row["CreationTime"], $row["UserID"]);
	}

	// setting antiflood rule
	$forum_antiflood = $AccessTable->set_generic_rule("forum", "post");

	switch ($action) {
		case "delete_message":
			if (is_admin() || $auth_edit) {
				requireVars($id);

				/* checking if this message is a topic by itself */
				$db->query("SELECT TopicID, is_Topic
				FROM ".db_table("forum_message")."
				WHERE ID = '{$id}'", __FILE__, __LINE__);

				if ($db->num_rows()) {

					$row = $db->fetch_row();

					if ($row["is_Topic"]) {

						/* Counting messages for this topic */
						$db->query("SELECT ID FROM ".db_table("forum_message")."
						WHERE TopicID = '{$row["TopicID"]}'", __FILE__, __LINE__);

						if (!is_admin() && ($db->num_rows() > 1)) {
							/* An ordinary user cannot delete a topic with replies */
							$stop = true;
						} elseif (is_admin()) {
							/* Deleting a topic means deleting the entire thread */
							$db->query("DELETE FROM ".db_table("forum_message")."
							WHERE TopicID = '{$row["TopicID"]}'");

							$db->query("DELETE FROM ".db_table("forum_thread")."
							WHERE ID = '{$id}'", __FILE__, __LINE__);

							$return = "../../index.php/forums";

							$stop = true;
						}
					}

					if (!isset($stop)) {
						$db->query("DELETE FROM ".db_table("forum_message")."
						WHERE ID = '{$id}' ".(is_admin() ? "" : "AND UserID = '{$row["UserID"]}'")."",
						__FILE__, __LINE__);
					}
				}

				slog("forums: deleted message '$id'", "actions", 1);
			} else {
				abort(accessDenied());
			}
		break;
		case "delete_category": {
			if (is_admin()) {
				requireVars ($id);
				forum_deleteCategory($id);
			}
		}
		case "move_category":
			if (is_admin()) {

				gpGlobalize("id, where");

				requireVars($id, $where);

				$w = ($where == "up") ? "<" : ">";

				$db->query("SELECT OrderID FROM ".db_table("forum_category")." WHERE ID = '$id'");

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$db->query("SELECT ID, OrderID FROM ".db_table("forum_category")."
					WHERE OrderID $w '{$row["OrderID"]}'
					ORDER BY OrderID ".(($w == "<") ? "DESC": "ASC")." LIMIT 1"
					,__FILE__, __LINE__);
					// this is the latest or upper block!
					if ($db->num_rows()) {
						$row2 = $db->fetch_row();
						// exchanging OrderID
						$db->query("UPDATE ".db_table("forum_category")." SET
							OrderID = '{$row2["OrderID"]}'
						WHERE ID = '{$id}'");
						$db->query("UPDATE ".db_table("forum_category")." SET
							OrderID = '{$row["OrderID"]}'
						WHERE ID = '{$row2["ID"]}'");

						slog("forums: category '$id' moved", "actions", 2);
					}
				}
			}
		break;
		case "move_forum":
			if (is_admin()) {

				gpGlobalize("id, where");

				requireVars($id, $where);

				$w = ($where == "up") ? "<" : ">";

				$db->query("SELECT CategoryID, OrderID FROM ".db_table("forum_forum")." WHERE ID = '$id'");

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$db->query("SELECT ID, OrderID FROM ".db_table("forum_forum")."
					WHERE CategoryID = '{$row["CategoryID"]}' AND OrderID $w '{$row["OrderID"]}'
					ORDER BY OrderID ".(($w == "<") ? "DESC": "ASC")." LIMIT 1"
					,__FILE__, __LINE__);
					// this is the latest or upper block!
					if ($db->num_rows()) {
						$row2 = $db->fetch_row();
						// exchanging OrderID
						$db->query("UPDATE ".db_table("forum_forum")." SET
							OrderID = '{$row2["OrderID"]}'
						WHERE ID = '{$id}'");
						$db->query("UPDATE ".db_table("forum_forum")." SET
							OrderID = '{$row["OrderID"]}'
						WHERE ID = '{$row2["ID"]}'");

						slog("forums: forum '$id' moved", "actions", 2);
					}
				}
			}
		break;
		case "delete_forum": {
			if (is_admin()) {
				requireVars ($id);
				forum_deleteForum($id);
			}
		}
		case "delete_thread":
			if (is_admin()) {
				/* forum id & category id */
				$db->query("SELECT t.ForumID, f.CategoryID
				FROM ".db_table("forum_thread")." t, ".db_table("forum_forum")."f
				WHERE t.ID = '{$id}' AND t.ForumID = f.ID", __FILE__, __LINE__);
				$row = $db->fetch_row();

				if ($db->num_rows()) {
					forum_deleteThread($id);
					$return = "../../index.php/forums/{$row["CategoryID"]}/{$row["ForumID"]}";
				}
			}
		break;
		case "thread_move":
			if (is_admin()) {
				gpGlobalize("to");
				requireVars($id, $to);

				$db->query("SELECT f.ID, f.CategoryID
				FROM ".db_table("forum_category")." c, ".db_table("forum_forum")." f, ".db_table("forum_thread")." t
				WHERE t.ID = '{$id}' AND f.CategoryID = c.ID AND t.ForumID = f.ID",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();

					$db->query("UPDATE ".db_table("forum_thread")." SET ForumID = '{$to}'
					WHERE ID = '{$id}'", __FILE__, __LINE__);

					$return = "../../index.php/forums/{$row["CategoryID"]}/$to";

					forum_updateForumInfo($to);
					forum_updateForumInfo($row["ID"]);

					slog("forums: moved thread '$id' to forum '$to'", "actions", 1);
				}

			}
		break;
		case "thread_mode":
			if (is_admin()) {
				gpGlobalize("mode");
				requireVars($id, $mode);
				switch ($mode) {
					case "lock": case "unlock":
						$mode_field = "mode_Locked";
						$mode_value = ($mode == "lock");
					break;
					case "stick": case "unstick":
						$mode_field = "mode_Sticked";
						$mode_value = ($mode == "stick");
					break;
				}
				if (isset($mode_field)) {
					$db->query("UPDATE ".db_table("forum_thread")." SET $mode_field = '$mode_value' WHERE ID = '$id'", __FILE__, __LINE__);

					/* forum id & category id */
					$db->query("SELECT t.ForumID, f.CategoryID
					FROM ".db_table("forum_thread")." t, ".db_table("forum_forum")."f
					WHERE t.ID = '{$id}' AND t.ForumID = f.ID", __FILE__, __LINE__);
					$row = $db->fetch_row();

					$return = "../../index.php/forums/{$row["CategoryID"]}/{$row["ForumID"]}";
					slog("forums: thread mode changed '$id'", "actions", 1);
				}
			}
		break;
		case "edit_message":
			/*
				users can edit his own message, even delete his own
				topic (if it has no replies) within a defined time
				interval
			*/

			gpGlobalize("id, category, forum, thread, nickname, email, topic, icon, content");

			requireVars($id, $category, $forum, $thread, $topic, $content);

			$auth = forum_checkAuth($category, $forum, $thread);

			if (is_admin() || ($auth_edit && $auth["post"])) {
				$db->query("
				UPDATE ".db_table("forum_message")." SET
					Icon = '{$icon}',
					Title = '{$topic}',
					Content = '{$content}',
					Nickname = '{$nickname}',
					ContactMail = '{$email}'
				WHERE ID = '{$id}' AND TopicID = '{$thread}' ".(is_admin() ? "" : " AND UserID = '{$User["ID"]}'")."
				", __FILE__, __LINE__);

				slog("forums: message edited '$id'", "actions", 1);
			} else {
				abort(accessDenied());
			}

		break;
		case "reply_topic":

			$AccessTable->load_rule($forum_antiflood, "E_ANTI_FLOOD");

			$allowed_categories = forum_getAllowedCategories();

			gpGlobalize("category, forum, thread, nickname, email, topic, icon, content");

			requireVars($category, $forum, $thread, $topic, $content);

			$auth = forum_checkAuth($category, $forum, $thread);

			if ($auth["reply"]) {
				$db->query("
				INSERT INTO ".db_table("forum_message")." (
					ID,
					TopicID,
					Icon,
					Title,
					Content,
					CreationTime,
					is_Topic,
					Nickname,
					ContactMail,
					UserID
				) VALUES (
					'".($msg = $db->free_id("forum_message"))."',
					'{$thread}',
					'{$icon}',
					'{$topic}',
					'{$content}',
					'".time()."',
					'0',
					'{$nickname}',
					'{$email}',
					'{$User["ID"]}'
				)",
				__FILE__, __LINE__);

				forum_updateThreadInfo($thread);

				$return = "../../index.php/forums/{$category}/{$forum}/{$thread}?page=last#{$msg}";

				slog("forums: thread replied '$id'", "actions", 2);
			}
		break;
		case "new_topic":

			$AccessTable->load_rule($forum_antiflood, _l("E_ANTI_FLOOD"));

			$allowed_categories = forum_getAllowedCategories();

			gpGlobalize("category, forum, nickname, email, topic, icon, content");

			requireVars($category, $forum, $topic, $content);

			$auth = forum_checkAuth($category, $forum);

			if ($auth["post"]) {

				$thread = $db->free_id("forum_thread");

				$db->query("INSERT INTO ".db_table("forum_thread")." (
						ID,
						ForumID,
						stat_Reads,
						stat_Replies,
						mode_Locked,
						mode_Sticked
					) VALUES (
						'{$thread}',
						'{$forum}',
						'0',
						'0',
						'0',
						'0'
					)
				", __FILE__, __LINE__);

				$db->query("INSERT INTO ".db_table("forum_message")." (
						ID,
						TopicID,
						Icon,
						Title,
						Content,
						CreationTime,
						is_Topic,
						Nickname,
						ContactMail,
						UserID
					) VALUES (
						'".$db->free_id("forum_message")."',
						'{$thread}',
						'{$icon}',
						'{$topic}',
						'{$content}',
						'".time()."',
						'1',
						'{$nickname}',
						'{$email}',
						'{$User["ID"]}'
					)", __FILE__, __LINE__);

					$return = "../../index.php/forums/{$category}/{$forum}/{$thread}";

					slog("forums: new forum thread '$id'", "actions", 2);
			} else {
				abort(accessDenied());
			}

		break;
		case "edit_category":

			if (is_admin()) {

				gpGlobalize("id, icon, status, orderid, name, description, auth_access, auth_post");

				requireVars($id, $name);

				table_simpleSwitchOrder("forum_category", $id, $orderid);

				// inserting into database
				$db->query ("
				UPDATE ".db_table("forum_category")." SET
					OrderID = '{$orderid}',
					Icon = '{$icon}',
					Name = '{$name}',
					Description = '{$description}',
					Status = '{$status}',
					auth_Access = '{$auth_access}',
					auth_Post = '{$auth_post}'
				WHERE ID = '{$id}'
				", __FILE__, __LINE__);

				slog("forums: modified category id='$id'", "actions", 1);
			}

		break;
		case "edit_forum":

			if (is_admin()) {

				gpGlobalize("id, icon, status, categoryid, orderid, name,
				description");

				requireVars($id, $categoryid, $name);

				table_simpleSwitchOrder("forum_forum", $id, $orderid);

				// inserting into database
				$db->query ("
				UPDATE ".db_table("forum_forum")." SET
					CategoryID = '{$categoryid}',
					OrderID = '{$orderid}',
					Icon = '{$icon}',
					Name = '{$name}',
					Description = '{$description}',
					Status = '{$status}'
				WHERE ID = '{$id}'
				", __FILE__, __LINE__);

				slog("forums: modified forum id='$id'", "actions", 1);
			}

		break;
		case "new_category":

			if (is_admin()) {

				gpGlobalize("icon, status, orderid, name, description, auth_access, auth_post");

				requireVars($name);

				// appending
				$db->query ("SELECT OrderID FROM ".db_table("forum_category")."
				ORDER BY OrderID ".(($orderid) ? "DESC" : "ASC")." LIMIT 1",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$orderid = $row["OrderID"] + ($orderid ? 1 : -1);
				} else {
					$orderid = 1;
				}

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("forum_category")."
					(
						ID,
						OrderID,
						Icon,
						Name,
						Description,
						Status,
						auth_Access,
						auth_Post
					)
						VALUES
					(
						'".$db->free_id("forum_category")."',
						'{$orderid}',
						'{$icon}',
						'{$name}',
						'{$description}',
						'{$status}',
						'{$auth_access}',
						'{$auth_post}'
					)
				", __FILE__, __LINE__);

				// saving preferences
				conf::setkey("forums", "default_auth_access", $auth_access, "string");
				conf::setkey("forums", "default_auth_post", $auth_post, "string");

				slog("forums: created category '$name'", "actions", 1);
			}
		break;
		case "new_forum":

			if (is_admin()) {

				gpGlobalize("icon, status, categoryid, orderid, name, description");

				requireVars($name, $categoryid);

				// appending
				$db->query ("SELECT OrderID FROM ".db_table("forum_forum")."
				ORDER BY OrderID ".(($orderid) ? "DESC" : "ASC")." LIMIT 1",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$orderid = $row["OrderID"] + ($orderid ? 1 : -1);
				} else {
					$orderid = 1;
				}

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("forum_forum")."
					(
						ID,
						CategoryID,
						OrderID,
						Icon,
						Name,
						Description,
						MessageCount,
						TopicCount,
						LastPostID,
						Status
					)
						VALUES
					(
						'".$db->free_id("forum_forum")."',
						'{$categoryid}',
						'{$orderid}',
						'{$icon}',
						'{$name}',
						'{$description}',
						'0',
						'0',
						'0',
						'{$status}'
					)
				", __FILE__, __LINE__);

				slog("forums: created forum '$name'", "actions", 1);
			}
		break;
		default:
			abort(_l("E_UNKNOWN_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>