<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/file.lib.php";
	require_once GEKKO_ROOT."lib/image.lib.php";
	require_once GEKKO_ROOT."modules/gallery/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	if (!is_admin()) abort(accessDenied());

	mkworkdir(GEKKO_ROOT."data/gallery/");

	switch ($action) {
		case "delete_item":
			execWithEach($id, "deleteGalleryItem");
		break;
		case "delete":
			execWithEach($id, "deleteGallery");
		break;
		case "enable":
			gallerySetStatus($id, "1");
		break;
		case "disable":
			gallerySetStatus($id, "0");
		break;
		case "edit":
			gpGlobalize("id, status, gallerylink, title, description, auth_access");

			requireVars($id, $title);

			// thumbnail required
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "data/gallery");
				if ($thumb) {
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("gallery", "thumbnail.longest_side"));
					$icon = $thumb["url"];
				} else {
					abort(_l("L_ERROR"));
				}
				// deleting old thumbnail
				$db->query("SELECT Thumbnail FROM ".db_table("gallery")." WHERE ID = '{$id}'", __FILE__, __LINE__);
				$row = $db->fetch_row();
				unlink(GEKKO_ROOT.$row["Thumbnail"]);
			} else {
				$thumb = false;
			}

			$db->query("UPDATE ".db_table("gallery")." SET
				Title = '{$title}',
				Description = '{$description}',
				GalleryLink = '{$gallerylink}',
				Status = '{$status}',
				AuthorID = '{$User["ID"]}',
				LastUpdated = '".time()."',
				".($thumb ? "Thumbnail = '{$thumb["url"]}'," : "")."
				".($thumb ? "ThumbnailSize = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
				auth_Access = '{$auth_access}'
			WHERE ID = '{$id}'
			", __FILE__, __LINE__);

			slog("gallery: gallery '$id' was updated", "actions", 1);
		break;
		case "create":

			gpGlobalize("status, gallerylink, title, description, auth_access");

			//requireVars($title);

			// thumbnail required
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "data/gallery");
				if ($thumb) {
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("gallery", "thumbnail.longest_side"));
				} else {
					abort(_l("L_ERROR"));
				}
			} else {
				abort(_l("E_INSUFFICIENT_DATA"));
			}

			if (!$title) $title = beauty_basename($thumb["origin"]);

			$db->query ("
			INSERT INTO ".db_table("gallery")."
				(
					ID,
					GalleryLink,
					Title,
					Description,
					Status,
					Thumbnail,
					ThumbnailSize,
					AuthorID,
					CreationTime,
					LastUpdated,
					auth_Access
				)
					VALUES
				(
					'".$db->free_id("gallery")."',
					'{$gallerylink}',
					'{$title}',
					'{$description}',
					'{$status}',
					'{$thumb["url"]}',
					'{$thumb["width"]}x{$thumb["height"]}',
					'{$User["ID"]}',
					'".time()."',
					'".time()."',
					'{$auth_access}'
				)
			", __FILE__, __LINE__);

			slog("gallery: new gallery '$title'", "actions", 2);
		break;
		case "edit_item":
			gpGlobalize("id, gallerylink, title, description, link_only,
			mediaurl, thumbnail, allowcomments");

			requireVars($id, $title, $gallerylink);

			// changed media
			$media = Array();
			if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
				$media = file_get("local_media", "remote_media", "data/gallery");
				if (!file_exists($media["abs_loc"])) {
					abort(_l("E_ERROR"));
				}
			} elseif ($link_only && $_POST["remote_media"]) {
				// only linking
				$media["rel_loc"] = $_POST["remote_media"];
				if (!$title) $title = beauty_basename($media);
				// checking if thumnbnail was provided
				if (!$_POST["remote_file"] && !$_FILES["local_file"]["size"]) {
					// thumbnail was not provided, but if media is an image, so we can try to make a copy in thumbnail size
					switch (get_media_type($media["rel_loc"])) {
						case "image":
							$_POST["remote_file"] = $media["rel_loc"];
						break;
					}
				}
			}

			// changed thumbnail
			$thumb = Array();
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "data/gallery");
				if ($thumb) {
					if ($link_only) {
						// saving image size before resizing
						$media["size"] = imagesize($thumb["abs_loc"]);
					}
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("gallery", "thumbnail.longest_side"));
				}
			}

			if ($media && !$thumb) {
				// no thumbnail was provided, media was changed, trying to update...
				switch (file_extension($media["basename"])) {
					case "jpg": case "jpeg": case "png": case "gif": case "xpm": case "tiff":
						$thumb = mkthumbnail($media["abs_loc"], conf::getKey("gallery", "thumbnail.longest_side"), false, false);
					break;
					default:
						abort(_l("E_COULDNT_CREATE_THUMBNAIL"));
					break;
				}
			}

			if ($media || $thumb) {
				// deleting old files
				$db->query("SELECT Thumbnail, MediaURL FROM ".db_table("gallery_item")."
				WHERE ID = '$id'", __FILE__, __LINE__);
				$row = $db->fetch_row();
				if ($media) @unlink(GEKKO_ROOT.$row["MediaURL"]);
				if ($thumb) @unlink(GEKKO_ROOT.$row["Thumbnail"]);
			}

			// default media size
			if ($media) {
				// default media size
				if (!isset($media["size"])) {
					$media["size"] = isset($media["abs_loc"]) ? imagesize($media["abs_loc"]) : "512x384";
				}
			}

			$db->query("UPDATE ".db_table("gallery_item")." SET
				GalleryLink = '{$gallerylink}',
				Title = '{$title}',
				Description = '{$description}',
				Thumbnail = '".(isset($thumb["url"]) ? $thumb["url"] : $thumbnail)."',
				".($thumb ? "ThumbnailSize = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
				MediaURL = '".(isset($media["rel_loc"]) ? $media["rel_loc"] : $mediaurl)."',
				".($media ? "MediaSize = '{$media["size"]}'," : "")."
				AuthorID = '{$User["ID"]}',
				LastUpdated = '".time()."',
				AllowComments = '{$allowcomments}'
			WHERE ID = '{$id}'", __FILE__, __LINE__);

			slog("gallery: item '$id' was updated", "actions", 1);
		break;
		case "add_item":

			unset($size);

			gpGlobalize("gallerylink, title, description, link_only, allowcomments");

			requireVars($gallerylink);

			$media = Array();

			// media is required
			if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
				// saving media
				$media = file_get("local_media", "remote_media", "data/gallery");
				if (!file_exists($media["abs_loc"])) {
					abort(_l("E_ERROR"));
				}
				if (!$title) $title = beauty_basename($media["basename"]);
			} elseif ($link_only && $_POST["remote_media"]) {
				// only linking
				$media["rel_loc"] = $_POST["remote_media"];
				if (!$title) $title = beauty_basename($media);
				// checking if thumnbnail was provided
				if (!$_POST["remote_file"] && !$_FILES["local_file"]["size"]) {
					// thumbnail was not provided, but if media is an image, so we can try to make a copy in thumbnail size
					switch (get_media_type($media["rel_loc"])) {
						case "image":
							$_POST["remote_file"] = $media["rel_loc"];
						break;
					}
				}
			} else {
				abort(_l("E_INSUFFICIENT_DATA"));
			}

			// custom thumbnail
			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file", "data/gallery");
				if ($thumb) {
					if ($link_only) {
						// saving image size before resizing
						$media["size"] = imagesize($thumb["abs_loc"]);
					}
					$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("gallery", "thumbnail.longest_side"));
				}
			} elseif (!$link_only) {
				// creating thumbnail taking media as base (when possible)
				switch (get_media_type($media["basename"])) {
					case "image":
						// we can create a thumbnail with the uploaded image
					break;
					default:
						// media is not an image! no thumbnail was provided... hmm!
						unlink($media["abs_loc"]);
						abort(_l("E_COULDNT_CREATE_THUMBNAIL"));
					break;
				}
				$thumb = mkthumbnail($media["abs_loc"], conf::getKey("gallery", "thumbnail.longest_side"), false, false);
			} else {
				abort(_l("E_COULDNT_CREATE_THUMBNAIL"));
			}

			if (!isset($thumb) || !file_exists($thumb["path"])) {
				unlink($media["abs_loc"]);
				abort(_l("E_COULDNT_CREATE_THUMBNAIL"));
			}

			// default media size
			if (!isset($media["size"])) {
				$media["size"] = isset($media["abs_loc"]) ? imagesize($media["abs_loc"]) : "512x384";
			}

			$db->query ("
			INSERT INTO ".db_table("gallery_item")."
				(
					ID,
					GalleryLink,
					Title,
					Description,
					Thumbnail,
					ThumbnailSize,
					MediaURL,
					MediaSize,
					AuthorID,
					CreationTime,
					LastUpdated,
					allowComments
				)
					VALUES
				(
					'".$db->free_id("gallery_item")."',
					'{$gallerylink}',
					'{$title}',
					'{$description}',
					'{$thumb["url"]}',
					'{$thumb["width"]}x{$thumb["height"]}',
					'{$media["rel_loc"]}',
					'{$media["size"]}',
					'{$User["ID"]}',
					'".time()."',
					'".time()."',
					'{$allowcomments}'
				)
			", __FILE__, __LINE__);

			slog("gallery: added item to gallery '$title'", "actions", 2);
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>