<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/users/main.lib.php";
	require_once GEKKO_ROOT."modules/news/main.lib.php";
	require_once GEKKO_ROOT."lib/format.lib.php";

	$action = _ext("action", 2);
	$page = _ext("page", 2);
	$id = _ext("id", 3);

	$categories = getCategories(true);

	switch ($action) {
		case "edit":
			if ($id) {

				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "news/index.admin.tpl");
				$tpl->insert("NEWS.FORM", "news/news.form.tpl");

				$db->query("
					SELECT
						ID, UserID, Icon, Category, Title, Introduction, Content,
						CreationTime, pageReads, Source, Status, AllowComments
					FROM ".db_table("news")." WHERE ID = '{$id}'
				");

				if ($db->num_rows()) {

					$row = $db->fetch_row();

					saneHTML($row, "Content");

					//$row["Content"] = user_env_vars($row["Content"]);

					$rtb_content = new rtbEditor($row["Content"]);
					$rtb_content->setSize(350, 300);

					$rtb_intro = new rtbEditor($row["Introduction"], "introduction");
					$rtb_intro->setSize(350, 150);

					$tpl->set_arr ($row);

					$tpl->set_arr (
						Array (
							"BLOCK_TITLE" => _l("L_NEWS"),
							"BLOCK_SUBTITLE" => _l("L_EDIT"),
							"BLOCK_ICON" => mkIcon("news", 16),
							"ICONCHOOSER" => mkIconChooser(16, $row["Icon"]),
							"STATUS.SEL" => mkSelect(getNewsStatus(), $row["Status"], "status"),
							"CATEGORIES.SEL" => mkSelect($categories, $row["Category"], "category"),
							"OPTIONS" => mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), $row["AllowComments"]),
							"ACTION" => "edit",
							"RETURN" => "../../index.php/admin/news",
							"RTBEDITOR.CONTENT" => $rtb_content->make(),
							"RTBEDITOR.INTRO" => $rtb_intro->make()
						)
					);
					$mcBuff = $tpl->make();
				}
			}
		break;
		default:

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "news/index.admin.tpl");
			$tpl->insert("NEWS.FORM", "news/news.form.tpl");

			$pager = $db->pager (
				"SELECT ID FROM ".db_table("news")." WHERE Status <= '1'",
				"index.php/admin/news/%p", $page, conf::getkey("news", "items_per_admin_page")
			);

			$db->query ("
				SELECT ID, UserID, Category, Icon, Title, Introduction,
				CreationTime, pageReads, Status
				FROM ".db_table("news")." WHERE Status <= '1'
				ORDER BY Status ASC, CreationTime DESC ".$pager["sql"]."
			", __FILE__, __LINE__);

			$news = $db->num_rows();

			while ($row = $db->fetch_row()) {
				saneHTML($row, "Introduction");
				if (!$row["Status"]) $row["Category"] .= " ("._l("L_DRAFT").")";

				$row["Introduction"] = mkIntro($row["Introduction"]);

				$row["Icon"] = mkIcon($row["Icon"], 16);
				$row["Category"] = getCategoryByID($row["Category"]);
				$row["Author"] = getUserByID($row["UserID"]);
				$row["Created"] = dateFormat($row["CreationTime"]);

				$row["Actions"] = Array();
				$row["Actions"][] = mkLink("index.php/admin/news/edit/".$row["ID"], _l("L_EDIT"));
				$row["Actions"][] = mkLink("modules/news/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1);
				if (!$row["Status"]) {
					$row["Actions"][] = mkLink("modules/news/main.act.php?action=publish&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_PUBLISH"));
					$row["Title"] .= " ("._l("L_DRAFT").")";
				}
				$row["Actions"] = mkButtonDisplay($row["Actions"]);

				$tpl->set_arr($row,"NEWS");
				$tpl->saveBuff("NEWS");
			}

			/* submissions */
			$db->query("SELECT ID, Category, Icon, Title, Introduction, CreationTime,
			UserID
			FROM ".db_table("news")."
			WHERE Status = '2'", __FILE__, __LINE__);

			$submissions = $db->num_rows();
			while ($row = $db->fetch_row()) {
				saneHTML($row, "Introduction");

				$row["Introduction"] = mkIntro($row["Introduction"]);

				$row["Icon"] = mkIcon($row["Icon"], 16);
				$row["Author"] = getUserById($row["UserID"]);
				$row["CategoryLink"] = getCategoryById($row["Category"]);
				$row["Submitted"] = dateFormat($row["CreationTime"]);

				$row["Actions"] = Array();
				$row["Actions"][] = mkLink("index.php/admin/news/edit/".$row["ID"], _l("L_EDIT"));
				$row["Actions"][] = mkLink("modules/news/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1);
				$row["Actions"][] = mkLink("modules/news/main.act.php?action=publish&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_PUBLISH"));
				$row["Actions"] = mkButtonDisplay($row["Actions"]);

				$tpl->set_arr($row, "SUBMISSION");
				$tpl->savebuff("SUBMISSION");
			}

			// Loading and setting up rtbEditor
			$rtb_content = new rtbEditor();
			$rtb_content->setSize(350, 300);

			$rtb_intro = new rtbEditor("", "introduction");
			$rtb_intro->setSize(350, 150);

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => _l("L_NEWS"),
					"BLOCK_SUBTITLE" => _l("L_COMPOSE"),
					"BLOCK_ICON" => mkIcon("news.png", 16),
					"ICONCHOOSER" => mkIconChooser(16, "news.png"),
					"STATUS.SEL" => mkSelect(getNewsStatus(), 1, "status"),
					"CATEGORIES.SEL" => mkSelect($categories, null, "category"),
					"NEWS" => $news,
					"SUBMISSIONS" => $submissions,
					"ACTION" => "create",
					"OPTIONS" =>  mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), 1),
					"TITLE" => "",
					"CONTENT" => "",
					"INTRODUCTION" => "",
					"SOURCE" => "",
					"ID" => 0,
					"RETURN" => "",
					"ENTRY_PAGER" => $pager["html"],
					"RTBEDITOR.CONTENT" => $rtb_content->make(),
					"RTBEDITOR.INTRO" => $rtb_intro->make()
				)
			);
			$mcBuff = $tpl->make();
		break;
	}


?>