<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class GekkoModule_Pages {
		function create_menu() {
			// don't need a menu entry
			return true;
		}
		function configure() {

		}
		function install() {
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("page")." (
				ID MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				Category SMALLINT (5) UNSIGNED NOT NULL,
				TextID VARCHAR (255),
				Title VARCHAR (128),
				Content TEXT,
				AuthorID MEDIUMINT (8) UNSIGNED NOT NULL,
				LastEditor MEDIUMINT (8) UNSIGNED NOT NULL,
				Created INT (11) UNSIGNED NOT NULL,
				Modified INT (11) UNSIGNED NOT NULL,
				Status ENUM('0','1') NOT NULL default '1',
				showTitle ENUM('0','1') NOT NULL default '1'
			)
			",__FILE__, __LINE__, true);

			# default values
			$GLOBALS["db"]->query("
				INSERT INTO ".db_table("page")." (
					Category,
					TextID,
					Title,
					Content,
					AuthorID,
					Created,
					Status
				) VALUES (
					1,
					'Index',
					'Index page',
					'Thanks for using Gekko!',
					'1',
					'".time()."',
					1
				);
			", __FILE__, __LINE__, true);

			modCore::registerModule($GLOBALS["cgdb"]["pages"], "pages", "*", $GLOBALS["cgdb"]["pages"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("page"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			if (check_version("0.5.7", $provided_v) < 0) {
				$GLOBALS["db"]->query("ALTER TABLE ".db_table("page")."
				CHANGE COLUMN Status Status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN showTitle showTitle ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
		}
		function ext_uninstall($module) {

		}
	}
?>