<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/polls/main.lib.php";
	require_once GEKKO_ROOT."lib/chart.lib.php";

	$action = _ext("action", 2);
	$id = _ext("id", 3);
	$page = _ext("page");

	$categories = getCategories(true);

	switch ($action) {
		case "edit":
			if ($id) {
				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "polls/index.admin.tpl");
				$tpl->insert("POLL.FORM", "polls/poll.form.tpl");

				$db->query("SELECT * FROM ".db_table("polls")."
				WHERE ID = '{$id}'", __FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();

					/* filling options */
					for ($i = 1; $i <= 10; $i++) {
						$tpl->set_arr (
							Array (
								"INDEX" => $i,
								"OPTDESCR" => $row["OptDescr_".$i],
								"OPTVOTES" => $row["OptVotes_".$i],
							),
						"OPTION"
						);
						$tpl->savebuff("OPTION");
						unset($row["OptDescr_".$i], $row["OptVotes_".$i]);
					}

					$tpl->set_arr ($row);
					$tpl->set_arr (
						Array (
							"BLOCK_ICON" => mkIcon("polls.png", 16),
							"BLOCK_TITLE" => _l("L_POLLS"),
							"BLOCK_SUBTITLE" => _l("L_EDIT_POLL"),
							"ACTION" => "edit",
							"CATEGORIES.SEL" => mkSelect($categories, $row["Category"], "category"),
							"STATUS.SEL" => booleanStatus($row["Status"]),
							"EXPIRES.SEL" => mkSelect(getVigency(), 0, "expires"),
							"OPTIONS" =>  mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), $row["AllowComments"])."<br />".mkCheckBox("changeexpiration", _l("L_CHANGE_EXPIRATION"), 0),
							"RETURN" => ""
						)
					);
					$mcBuff = $tpl->make();
				} else {
					$mcBuff = "";
				}
			}
		break;
		default:

			/* requires at least one category to work! */

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "polls/index.admin.tpl");
			$tpl->insert("POLL.FORM", "polls/poll.form.tpl");

			/* setting options and votes as null */
			for ($i = 1; $i <= 10; $i++) {
				$tpl->set_arr (
					Array (
						"INDEX" => $i,
						"OPTDESCR" => "",
						"OPTVOTES" => "0"
					),
					"OPTION"
				);
				$tpl->savebuff("OPTION");
			}

			/* listing polls */
			$pager = $db->pager (
				"SELECT ID FROM ".db_table("polls")." ORDER BY Expires DESC, Title ASC",
				"index.php/admin/polls?page=%p", $page, conf::getkey("polls", "items_per_admin_page")
			);

			$db->query("SELECT * FROM ".db_table("polls")." ORDER BY Expires DESC, Title ASC {$pager["sql"]}",
			__FILE__, __LINE__);

			$polls = $db->num_rows();
			while ($row = $db->fetch_row()) {
				/* poll chart */
				$chart = new Chart("80%", true);
				/* adding valid options to chart */
				for ($i = 1; $i <= 10; $i++) {
					if (trim($row["OptDescr_$i"])) {
						$chart->addItem($row["OptDescr_$i"], $row["OptVotes_$i"]);
					}
				}
				$row["CHART"] = $chart->make();
				unset($chart);


				/* actions */
				$row["Actions"] = Array();
				$row["Actions"][] = mkLink("index.php/admin/polls/edit/".$row["ID"], _l("L_EDIT"));
				$row["Actions"][] = mkLink("modules/polls/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1);
				$row["Actions"][] = mkLink("modules/polls/main.act.php?action=createblock&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_CREATE_BLOCK"));
				if (!$row["Status"]) {
					$row["Actions"][] = mkLink("modules/polls/main.act.php?action=enable&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_ENABLE"));
				}
				$row["Actions"] = mkButtonDisplay($row["Actions"]);

				$row["Expires"] = getExpirationDate($row["Expires"]);
				$row["Category"] = getCategoryById($row["Category"]);
				$tpl->set_arr ($row, "POLL");
				$tpl->savebuff("POLL");
			}

			$tpl->set_arr (
				Array (
					"BLOCK_ICON" => mkIcon("polls.png", 16),
					"BLOCK_TITLE" => _l("L_POLLS"),
					"BLOCK_SUBTITLE" => _l("L_CREATE_POLL"),
					"TITLE" => "",
					"ACTION" => "create",
					"CATEGORIES.SEL" => mkSelect($categories, null, "category"),
					"STATUS.SEL" => booleanStatus(1),
					"EXPIRES.SEL" => mkSelect(getVigency(), 0, "expires"),
					"OPTIONS" =>  mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), 1),
					"POLLS" => $polls,
					"DESCRIPTION" => "",
					"PAGER" => $pager["html"],
					"RETURN" => ""
				)
			);
			$mcBuff = $tpl->make();

		break;
	}

?>