<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title>Poll</title>
			<description>Shows: the latests poll (if id = -1), random poll (if id = 0) or the poll specified by it's id</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
		<info lang="es">
			<title>Encuesta</title>
			<description><![CDATA[Muestra: la &uacute;ltima encuesta (si id = -1), encuesta aleatoria (si id = 0) o la encuesta especificada por su id]]></description>
		</info>
		<variable name="id">-1</variable>
		<variable name="limit">1</variable>
	</blockscript>
	<%%>
	*/

	require_once GEKKO_ROOT."modules/categories/main.lib.php";
	require_once GEKKO_ROOT."modules/polls/main.lib.php";
	require_once GEKKO_ROOT."lib/chart.lib.php";

	$cat_lock = getAllowedCategories(true);

	$q = $GLOBALS["db"]->query("SELECT * FROM ".db_table("polls")."
	WHERE ".(($id < 0) ? "": (($id > 0) ? "ID = '{$id}' AND " : ""))."Status = '1' AND ($cat_lock)
	ORDER BY ".($id ? "Created DESC" : "RAND()")." LIMIT $limit", __FILE__, __LINE__, true);

	$return = Array();
	while ($row = $GLOBALS["db"]->fetch_row($q)) {
		$tpl = new ContentBlock();
		$tpl->load("polls/show.block.tpl");

		$expired = pollHasExpired($row["Expires"]);

		if ($expired || alreadyVoted($row["ID"])) {
			/* chart */
			$chart = new Chart("150px", true);
			for ($i = 1; $i <= 10; $i++) {
				if (trim($row["OptDescr_$i"])) {
					$chart->addItem($row["OptDescr_$i"], $row["OptVotes_$i"]);
				}
			}
			$row["POLL.CHART"] = $chart->make();
			unset ($chart);
		} else {
			$tpl->insert("POLL.FORM", "polls/vote.form.tpl");
			for ($i = 1; $i <= 10; $i++) {
				if (trim($row["OptDescr_$i"])) {
					$tpl->set_arr(
						Array(
							"ID"=> $i,
							"OPTION" => $row["OptDescr_$i"]
						),
					"OPTION");
					$tpl->savebuff("OPTION");
				}
			}
			$row["POLL.VOTE"] = true;
		}

		$row["Category"] = getCategoryById($row["Category"]);
		$row["RETURN"] = $_SERVER["REQUEST_URI"];
		$row["EXPIRED"] = $expired ? _l("L_POLL_HAS_EXPIRED"): "";

		$tpl->set_arr($row);
		$return[] = $tpl->make();
	}
	$return = implode("<hr />", $return);

?>