<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class GekkoModule_Polls {
		function create_menu() {
			return false;
		}
		function configure() {
			Conf::getKey("polls", "items_per_page", 8, "i");
			Conf::getKey("polls", "items_per_admin_page", 3, "i");
			Conf::getKey("polls", "allow_user_comments", 1, "b");
		}
		function install() {
			/*
				A friend of mine told me that table names shouldn't be named as
				plural since they are "single entities"

				This table is named as plural because "comments" module needs
				the principal table to own the same name as it's module
			*/

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("polls")." (
				ID MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				Category SMALLINT (5) UNSIGNED NOT NULL,
				Title VARCHAR (64),
				Description VARCHAR (255),
				AuthorID MEDIUMINT (8) UNSIGNED NOT NULL,
				Created INT (11) UNSIGNED NOT NULL,
				Expires INT (11) UNSIGNED NOT NULL,
				OptDescr_1 VARCHAR (128),
				OptVotes_1 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_2 VARCHAR (128),
				OptVotes_2 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_3 VARCHAR (128),
				OptVotes_3 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_4 VARCHAR (128),
				OptVotes_4 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_5 VARCHAR (128),
				OptVotes_5 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_6 VARCHAR (128),
				OptVotes_6 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_7 VARCHAR (128),
				OptVotes_7 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_8 VARCHAR (128),
				OptVotes_8 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_9 VARCHAR (128),
				OptVotes_9 SMALLINT (5) UNSIGNED NOT NULL,
				OptDescr_10 VARCHAR (128),
				OptVotes_10 SMALLINT (5) UNSIGNED NOT NULL,
				Status ENUM('0','1') NOT NULL default '1',
				AllowComments ENUM('0','1') NOT NULL default '1'
			)
			",__FILE__, __LINE__, true);

			modCore::registerModule($GLOBALS["cgdb"]["polls"], "polls", "*", $GLOBALS["cgdb"]["polls"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("polls"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			if (check_version("0.5.8", $provided_v) < 0) {
				$GLOBALS["db"]->query("ALTER TABLE ".db_table("polls")."
				CHANGE COLUMN Status Status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN AllowComments AllowComments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>