<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."lib/chart.lib.php";
	require_once GEKKO_ROOT."modules/statistics/main.lib.php";

	$action = _ext("action", 2);
	$date = _ext("date", 3);
	$show = _ext("show", 3);

	switch ($action) {
		case "logs":
			header("content-type: text/plain");

			if (!$show || ($show != "referer")) $show = "request";

			$db->query("SELECT Counter, URL, LastIP, LastTime
			FROM ".db_table("stats_uri_logs")."
			WHERE Type = '{$show}' ORDER BY Counter DESC");

			while ($row = $db->fetch_row()) {
				printf("[%16s, %19s] %5d %s\n", $row["LastIP"], date("d/m/Y h:i:s", $row["LastTime"]), $row["Counter"], $row["URL"]);
			}

			abort();
		break;
		case "view":
			if (!$date) break;
			$date = explode(".", $date);

			$year = $month = $day = null;

			if (isset($date[0])) $year = $date[0];
			if (isset($date[1])) $month = $date[1];
			if (isset($date[2])) $day = $date[2];

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "statistics/index.admin.tpl");

			// we'll change those variables, saving before change
			$tpl->set_arr (
				Array (
					"DAY" => $day,
					"MONTH" => $month,
					"YEAR" => $year
				)
			);

			$chart = new Chart();

			if ($year && $month && $day) {

				// h00,h001,...h0023
				$fields = Array();
				for ($i = 0; $i < 24; $i++) {
					$fields[] = "H".str_repeat("0", (2-strlen($i))).$i;
				}

				$db->query("SELECT ".implode(", ", $fields).", Total
				FROM ".db_table("stats_visits")."
				WHERE Year = '$year' AND Month = '$month' AND Day = '$day'",
				__FILE__, __LINE__);

				if (!$db->num_rows()) break;

				$row = $db->fetch_row();
				foreach ($fields as $hour) {
					$chart->addItem(substr($hour, 1), $row["$hour"]);
				}

				$vtime = mktime(0,0,0,$month,$day,$year);

				$tpl->set("DETAILED.TITLE", strftime("%A %e, %B, %Y", $vtime));

			} elseif ($year && $month) {
				$db->query("SELECT Day, Total FROM ".db_table("stats_visits")."
				WHERE Year = '$year' AND Month = '$month'", __FILE__, __LINE__);

				if (!$db->num_rows()) break;

				$buff = Array();
				while ($row = $db->fetch_row()) {
					$buff[$row["Day"]] = $row["Total"];
				}
				$days = date("t", mktime(0,0,0,$month,1,$year));

				//
				if ($year == date("Y") && $month == date("m") && $days > date("d")) {
					$days = date("d");
				}

				for ($day = 1; $day <= $days; $day++) {
					$chart->addItem(mkLink("index.php/admin/statistics/view/{$year}.{$month}.{$day}", strftime("%A %e", mktime(0,0,0,$month,$day,$year))), isset($buff[$day]) ? $buff[$day] : 0);
				}

				$tpl->set("DETAILED.TITLE", strftime("%B, %Y", mktime(0,0,0,$month,$day,$year)));

			} else {
				$db->query("SELECT Month, Total FROM ".db_table("stats_visits")."
				WHERE Year = '$year'", __FILE__, __LINE__);

				$buff = Array();
				while ($row = $db->fetch_row()) {
					$buff[$row["Month"]] = $row["Total"];
				}

				for ($month = 1; $month <= 12; $month++) {
					$chart->addItem(mkLink("index.php/admin/statistics/view/{$year}.{$month}", strftime("%B", mktime(0,0,0,$month,1,$year))), isset($buff[$month]) ? $buff[$month] : 0);
				}

				$tpl->set("DETAILED.TITLE", strftime("%Y", mktime(0,0,0,$month,$day,$year)));

			}

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => _l("L_DETAILED_STATISTICS"),
					"BLOCK_ICON" => mkIcon("statistics.png", 16),
					"DETAILED.CHART" => $chart->make()
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "statistics/index.admin.tpl");

			$stats = false;
			// user statistics
			$db->query ("
				SELECT Type, Variable, Counter FROM ".db_table("stats_counter")."
				WHERE Type = 'user-agent' OR Type = 'user-agent-os'
				",
			__FILE__, __LINE__);

			$stats = $db->num_rows();

			$charts = Array();

			while ($row = $db->fetch_row()) {
				if (!isset($charts[$row["Type"]])) $charts[$row["Type"]] = new Chart("300px");
				switch ($row["Type"]) {
					case "user-agent":
						$text = isset($stats_user_agent[$row["Variable"]]) ? $stats_user_agent[$row["Variable"]] : $stats_user_agent["_unknown"];
					break;
					case "user-agent-os":
						$text = isset($stats_os[$row["Variable"]]) ? $stats_os[$row["Variable"]] : $stats_os["_unknown"];
					break;
				}
				$charts[$row["Type"]]->addItem($text, $row["Counter"]);
			}

			$db->query ("SELECT Day, Total FROM ".db_table("stats_visits")."
			WHERE Year = '".date("Y")."' AND Month = '".date("m")."'",
			__FILE__, __LINE__);

			$charts["month"] = new Chart("300px");
			while ($row = $db->fetch_row()) {
				$charts["month"]->addItem(mkLink("index.php/admin/statistics/view/".date("Y").".".date("m").".".$row["Day"]."", strftime("%A %e", mktime(0,0,0,date("m"),$row["Day"],date("Y")))), $row["Total"]);
			}

			// totals
			$db->query ("SELECT Variable, Counter FROM ".db_table("stats_counter")."
			WHERE Type = 'total' AND
			(Variable = 'unique-visits' OR Variable = 'clicks')",
			__FILE__, __LINE__);

			$tpl->set_arr(
				Array (
					"TOTAL_VISITORS" => 0,
					"TOTAL_CLICKS" => 0
				)
			);
			while ($row = $db->fetch_row()) {
				switch ($row["Variable"]) {
					case "unique-visits":
						$tpl->set("TOTAL_VISITORS", $row["Counter"]);
					break;
					case "clicks":
						$tpl->set("TOTAL_CLICKS", $row["Counter"]);
					break;
				}
			}

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => _l("L_STATISTICS"),
					"BLOCK_ICON" => mkIcon("statistics.png", 16),
					"DETAILED.TITLE" => _l("L_MONTH_STATISTICS"),
					"USER_AGENT.CHART" => isset($charts["user-agent"]) ? $charts["user-agent"]->make() : "",
					"USER_OS.CHART" => isset($charts["user-agent-os"]) ? $charts["user-agent-os"]->make() : "",
					"DETAILED.CHART" => isset($charts["month"]) ? $charts["month"]->make() : "",
					"STATS" => $stats,
					"GENERAL.STATS" => true,
					"BUTTONS" => mkButtonDisplay (
						Array (
							mkLink("index.php/admin/statistics/logs/referer", _l("L_REFERER_LOGS")),
							mkLink("index.php/admin/statistics/logs/request", _l("L_URL_LOGS")),
							mkLink("modules/statistics/main.act.php?action=clear&auth="._l("C_AUTH_STR")."", _l("L_CLEAR_LOGS"), false, true)
						)
					),
					"DAY" => date("d"),
					"MONTH" => date("m"),
					"YEAR" => date("Y")
				)
			);

			$mcBuff = $tpl->make();

		break;
	}

?>